3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
9 # For repeatability, reset the environment to known value.
15 export LANG LC_ALL PAGER TERM TZ
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
35 unset GIT_EXTERNAL_DIFF
37 unset GIT_OBJECT_DIRECTORY
38 unset GIT_CEILING_DIRECTORIES
39 unset SHA1_FILE_DIRECTORIES
40 unset SHA1_FILE_DIRECTORY
42 export GIT_MERGE_VERBOSITY
43 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
46 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
48 # Protect ourselves from common misconfiguration to export
49 # CDPATH into the environment
52 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
61 # Each test should start with something like this, after copyright notices:
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM=$ORIGINAL_TERM &&
71 tput bold >/dev/null 2>&1 &&
72 tput setaf 1 >/dev/null 2>&1 &&
73 tput sgr0 >/dev/null 2>&1
80 -d|--d|--de|--deb|--debu|--debug)
82 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
84 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
86 -h|--h|--he|--hel|--help)
88 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
90 -q|--q|--qu|--qui|--quie|--quiet)
102 if test -n "$color"; then
108 error) tput bold; tput setaf 1;; # bold red
109 skip) tput bold; tput setaf 2;; # bold green
110 pass) tput setaf 2;; # green
111 info) tput setaf 3;; # brown
112 *) test -n "$quiet" && return;;
122 test -z "$1" && test -n "$quiet" && return
129 say_color error "error: $*"
138 test "${test_description}" != "" ||
139 error "Test script did not set test_description."
141 if test "$help" = "t"
143 echo "$test_description"
148 if test "$verbose" = "t"
152 exec 4>/dev/null 3>/dev/null
162 echo >&5 "FATAL: Unexpected exit with code $?"
168 # The semantics of the editor variables are that of invoking
169 # sh -c "$EDITOR \"$@\"" files ...
171 # If our trash directory contains shell metacharacters, they will be
172 # interpreted if we just set $EDITOR directly, so do a little dance with
173 # environment variables to work around this.
175 # In particular, quoting isn't enough, as the path may contain the same quote
180 VISUAL='"$FAKE_EDITOR"'
185 if test -z "${test_tick+set}"
189 test_tick=$(($test_tick + 60))
191 GIT_COMMITTER_DATE="$test_tick -0700"
192 GIT_AUTHOR_DATE="$test_tick -0700"
193 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
196 # You are not expected to call test_ok_ and test_failure_ directly, use
197 # the text_expect_* functions instead.
200 test_count=$(expr "$test_count" + 1)
201 test_success=$(expr "$test_success" + 1)
202 say_color "" " ok $test_count: $@"
206 test_count=$(expr "$test_count" + 1)
207 test_failure=$(expr "$test_failure" + 1);
208 say_color error "FAIL $test_count: $1"
210 echo "$@" | sed -e 's/^/ /'
211 test "$immediate" = "" || { trap - exit; exit 1; }
214 test_known_broken_ok_ () {
215 test_count=$(expr "$test_count" + 1)
216 test_fixed=$(($test_fixed+1))
217 say_color "" " FIXED $test_count: $@"
220 test_known_broken_failure_ () {
221 test_count=$(expr "$test_count" + 1)
222 test_broken=$(($test_broken+1))
223 say_color skip " still broken $test_count: $@"
227 test "$debug" = "" || eval "$1"
237 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
238 this_test="$this_test.$(expr "$test_count" + 1)"
240 for skp in $GIT_SKIP_TESTS
249 say_color skip >&3 "skipping test: $@"
250 test_count=$(expr "$test_count" + 1)
251 say_color skip "skip $test_count: $1"
260 test_expect_failure () {
262 error "bug in the test script: not 2 parameters to test-expect-failure"
265 say >&3 "checking known breakage: $2"
267 if [ "$?" = 0 -a "$eval_ret" = 0 ]
269 test_known_broken_ok_ "$1"
271 test_known_broken_failure_ "$1"
277 test_expect_success () {
279 error "bug in the test script: not 2 parameters to test-expect-success"
282 say >&3 "expecting success: $2"
284 if [ "$?" = 0 -a "$eval_ret" = 0 ]
294 test_expect_code () {
296 error "bug in the test script: not 3 parameters to test-expect-code"
299 say >&3 "expecting exit code $1: $3"
301 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
311 # test_external runs external test scripts that provide continuous
312 # test output about their progress, and succeeds/fails on
313 # zero/non-zero exit code. It outputs the test output on stdout even
314 # in non-verbose mode, and announces the external script with "* run
315 # <n>: ..." before running it. When providing relative paths, keep in
316 # mind that all scripts run in "trash directory".
317 # Usage: test_external description command arguments...
318 # Example: test_external 'Perl API' perl ../path/to/test.pl
321 error >&5 "bug in the test script: not 3 parameters to test_external"
324 if ! test_skip "$descr" "$@"
326 # Announce the script to reduce confusion about the
327 # test output that follows.
328 say_color "" " run $(expr "$test_count" + 1): $descr ($*)"
329 # Run command; redirect its stderr to &4 as in
330 # test_run_, but keep its stdout on our stdout even in
337 test_failure_ "$descr" "$@"
342 # Like test_external, but in addition tests that the command generated
343 # no output on stderr.
344 test_external_without_stderr () {
345 # The temporary file has no (and must have no) security
347 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
348 stderr="$tmp/git-external-stderr.$$.tmp"
349 test_external "$@" 4> "$stderr"
350 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
351 descr="no stderr: $1"
353 say >&3 "expecting no stderr from previous command"
354 if [ ! -s "$stderr" ]; then
358 if [ "$verbose" = t ]; then
359 output=`echo; echo Stderr is:; cat "$stderr"`
363 # rm first in case test_failure exits.
365 test_failure_ "$descr" "$@" "$output"
369 # This is not among top-level (test_expect_success | test_expect_failure)
370 # but is a prefix that can be used in the test script, like:
372 # test_expect_success 'complain and die' '
374 # do something else &&
375 # test_must_fail git checkout ../outerspace
378 # Writing this as "! git checkout ../outerspace" is wrong, because
379 # the failure could be due to a segv. We want a controlled failure.
383 test $? -gt 0 -a $? -le 129 -o $? -gt 192
386 # test_cmp is a helper function to compare actual and expected output.
387 # You can use it like:
389 # test_expect_success 'foo works' '
390 # echo expected >expected &&
392 # test_cmp expected actual
395 # This could be written as either "cmp" or "diff -u", but:
396 # - cmp's output is not nearly as easy to read as diff -u
397 # - not all diff versions understand "-u"
403 # Most tests can use the created repository, but some may need to create more.
404 # Usage: test_create_repo <directory>
405 test_create_repo () {
407 error "bug in the test script: not 1 parameter to test-create-repo"
411 cd "$repo" || error "Cannot setup test environment"
412 "$GIT_EXEC_PATH/git" init "--template=$GIT_EXEC_PATH/templates/blt/" >&3 2>&4 ||
413 error "cannot run git init -- have you built things yet?"
414 mv .git/hooks .git/hooks-disabled
420 test_results_dir="$TEST_DIRECTORY/test-results"
421 mkdir -p "$test_results_dir"
422 test_results_path="$test_results_dir/${0%-*}-$$"
424 echo "total $test_count" >> $test_results_path
425 echo "success $test_success" >> $test_results_path
426 echo "fixed $test_fixed" >> $test_results_path
427 echo "broken $test_broken" >> $test_results_path
428 echo "failed $test_failure" >> $test_results_path
429 echo "" >> $test_results_path
431 if test "$test_fixed" != 0
433 say_color pass "fixed $test_fixed known breakage(s)"
435 if test "$test_broken" != 0
437 say_color error "still have $test_broken known breakage(s)"
438 msg="remaining $(($test_count-$test_broken)) test(s)"
440 msg="$test_count test(s)"
442 case "$test_failure" in
444 say_color pass "passed all $msg"
446 test -d "$remove_trash" &&
447 cd "$(dirname "$remove_trash")" &&
448 rm -rf "$(basename "$remove_trash")"
453 say_color error "failed $test_failure among $msg"
459 # Test the binaries we have just built. The tests are kept in
460 # t/ subdirectory and are run in 'trash directory' subdirectory.
461 TEST_DIRECTORY=$(pwd)
462 PATH=$TEST_DIRECTORY/..:$PATH
463 GIT_EXEC_PATH=$(pwd)/..
464 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
466 GIT_CONFIG_NOSYSTEM=1
467 GIT_CONFIG_NOGLOBAL=1
468 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
470 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
472 test -d ../templates/blt || {
473 error "You haven't built things yet, have you?"
476 if ! test -x ../test-chmtime; then
477 echo >&2 'You need to build test-chmtime:'
478 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
482 . ../GIT-BUILD-OPTIONS
485 test="trash directory.$(basename "$0" .sh)"
486 test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
489 echo >&5 "FATAL: Cannot prepare test area"
493 test_create_repo "$test"
494 # Use -P to resolve symlinks in our working directory so that the cwd
495 # in subprocesses like git equals our $PWD (for pathname comparisons).
496 cd -P "$test" || exit 1
498 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
499 for skp in $GIT_SKIP_TESTS
502 for skp in $GIT_SKIP_TESTS
511 say_color skip >&3 "skipping test $this_test altogether"
512 say_color skip "skip all tests in $this_test"